#ARV reclassification R code.R
#Last Modified:  04AUG2014
#Last Modified by:  M. Giganti


#Previously, an investigator classified each unique ARV combination as a certain regimen class (NNRTI,BOOSTED PI, OTHER, non-HAART).  As we see more unique ARV combinations, this strategy is becoming inefficient.
#Here, we break each individual drug as NRTI,NNRTI,PI,OTHER
#Then, we make rules for the given number of drug classes that comprise certain regimens
#Eventually, Karu will hardcode this into the database.
#For now, Giganti softcoding it for each analysis

#04AUG2014 - simplify non-HAART classification to just three lines

ARVreclassification<-function(OneMat){
    
    
    OneMat$regimen<-with(OneMat,
    ifelse ((NRTI+ NNRTI+ PI + OTHER)<=2,"non-HAART",
    ifelse ((NRTI+ NNRTI+OTHER)==0 & PI==2.5,"non-HAART",
	ifelse ((NRTI+ NNRTI+OTHER)<2 & PI==1.5,"non-HAART",
	ifelse((NRTI==2 | NRTI==3 | NRTI==4) & NNRTI==1 & PI==0 & OTHER==0, "NNRTI",
	ifelse((NRTI==2 | NRTI==3 | NRTI==4) & NNRTI==0 & (PI==1.5 | PI==2.5 | PI==3.5) & OTHER==0, "Boosted PI",
	ifelse(NRTI==2 & NNRTI==0 & PI==2 & OTHER==0, "PI",
	ifelse((NRTI==3) & NNRTI==0 & PI==0 & OTHER==0, "3 NRTI",
	ifelse((NRTI==4) & NNRTI==0 & PI==0 & OTHER==0, "other",
	##From this point forward, we need to give careful consideration
	ifelse((NRTI==2 | NRTI==3 | NRTI==4) & NNRTI==0 & PI==0 & OTHER>0, "other",
	ifelse((NRTI==2 | NRTI==3 | NRTI==4) & NNRTI==0 & (PI==0.5 | PI==1| PI==2) & (OTHER==0 | OTHER==1 | OTHER==2), "PI",
	ifelse(NRTI==1 & NNRTI==0 & (PI==0.5 | PI==1 | PI==2) & OTHER==1, "PI",
	ifelse((NRTI==1 | NRTI==2 | NRTI==3) & NNRTI==0 & (PI==1.5 | PI==2.5) & OTHER==1, "Boosted PI",
	ifelse((NRTI==1 | NRTI==2 | NRTI==3 | NRTI==4) & NNRTI==1 & PI==0 & OTHER==1, "NNRTI",
	ifelse((NRTI==0) & NNRTI==1 & PI==0 & OTHER==2, "NNRTI",
	ifelse(NRTI==1 & NNRTI==0 & PI==2 & OTHER==0, "PI",
	ifelse(NRTI==1 & NNRTI==0 & PI==2.5 & OTHER==0, "Boosted PI",
	ifelse((NRTI==0 | NRTI==1 | NRTI==2 | NRTI==3) & NNRTI==0 & (PI==1.5) & (OTHER==2 | OTHER==3), "Boosted PI",
	ifelse((NRTI==0 | NRTI==1 | NRTI==2 | NRTI==3) & NNRTI==0 & (PI==2.5) & (OTHER==1 | OTHER==2 | OTHER==3), "Boosted PI",
	####
	ifelse(NRTI==0 & NNRTI>0 & (PI==0.5 | PI==1 | PI==1.5)   & OTHER==0, "non-HAART",
	ifelse(NNRTI==1 & PI>0, "other",	 #What to do with patients with an NNRTI and a PI?
	ifelse(NNRTI==2 , "NNRTI",	  #This is likely mistake - Query?
	"Unclassifiable"))))))))))))))))))))))
    
    
    
    OneMat[OneMat$regimen=="Unclassifiable",]
    
    
    return(OneMat$regimen)
}

